searchData={"items":[{"type":"module","title":"meck","doc":"Module mocking library for Erlang.","ref":"meck.html"},{"type":"function","title":"meck.called/3","doc":"Equivalent to called(Mod, Fun, Args, '_') . Returns whether Mod:Func has been called with Args .","ref":"meck.html#called/3"},{"type":"function","title":"meck.called/4","doc":"Returns whether Pid has called Mod:Func with Args . This will check the history for the module, Mod , to determine whether process Pid call the function, Fun , with arguments, Args . If so, this function returns true, otherwise false. Wildcards can be used, at any level in any term, by using the underscore atom: '_' See also: called/3 .","ref":"meck.html#called/4"},{"type":"function","title":"meck.capture/5","doc":"Equivalent to capture(Occur, Mod, Func, OptArgsSpec, ArgNum, '_') . Returns the value of an argument as it was passed to a particular function call, It fails with not_found error if a function call of interest has never been made. It retrieves the value of argument at ArgNum position as it was passed to function call Mod:Func with arguments that match OptArgsSpec that occurred Occur 'th according to the call history. Atoms first and last can be used in place of the occurrence number to retrieve the argument value passed when the function was called the first or the last time respectively.","ref":"meck.html#capture/5"},{"type":"function","title":"meck.capture/6","doc":"Returns the value of an argument as it was passed to a particular function call made by a particular process. It fails with not_found error if a function call of interest has never been made. It retrieves the value of argument at ArgNum position as it was passed to function call Mod:Func with arguments that match OptArgsSpec made by process CallerPid that occurred Occur 'th according to the call history. Atoms first and last can be used in place of the occurrence number to retrieve the argument value passed when the function was called the first or the last time respectively. If an occurrence of a function call irrespective of the calling process needs to be captured then _ might be passed as OptCallerPid , but it is better to use capture/5 instead.","ref":"meck.html#capture/6"},{"type":"function","title":"meck.delete/3","doc":"Deletes an expectation. Deletes the expectation for the function Func with the matching arity Arity . If the mock has passthrough enabled, this function restores the expectation to the original function. See delete/4 .","ref":"meck.html#delete/3"},{"type":"function","title":"meck.delete/4","doc":"Deletes an expectation. Deletes the expectation for the function Func with the matching arity Arity . Force is a flag to delete the function even if it is passthrough.","ref":"meck.html#delete/4"},{"type":"function","title":"meck.exception/2","doc":"Throws an expected exception inside an expect fun. This exception will get thrown without invalidating the mocked module. That is, the code using the mocked module is expected to handle this exception. Note: this code should only be used inside an expect fun.","ref":"meck.html#exception/2"},{"type":"function","title":"meck.exec/1","doc":"Creates a ret_spec() from a function. Calls to an expect, created with ret_spec() returned by this function, will be forwarded to the specified function.","ref":"meck.html#exec/1"},{"type":"function","title":"meck.expect/3","doc":"Add expectation for a function Func to the mocked modules Mod . An expectation is either of the following: function() a stub function that is executed whenever the function Func is called. The arity of function() identifies for which particular Func variant an expectation is created for (that is, a function with arity 2 will generate an expectation for Func/2 ). [ func_clause_spec() ] a list of arg_spec() / ret_spec() pairs. Whenever the function Func is called the arguments are matched against the arg_spec() in the list. As soon as the first match is found then a value defined by the corresponding ret_spec() is returned. It affects the validation status of the mocked module(s). If an expectation is called with the wrong number of arguments or invalid arguments the mock module(s) is invalidated. It is also invalidated if an unexpected exception occurs.","ref":"meck.html#expect/3"},{"type":"function","title":"meck.expect/4","doc":"Equivalent to expect(Mod, Func, [{ArgsSpec, RetSpec}]) . Adds an expectation with the supplied arity and return value. This creates an expectation that has the only clause { ArgsSpec , RetSpec }.","ref":"meck.html#expect/4"},{"type":"function","title":"meck.expects/1","doc":"Returns the list of expectations. Returns the list of MFAs that were replaced by expectations","ref":"meck.html#expects/1"},{"type":"function","title":"meck.expects/2","doc":"Returns the list of expectations. Returns the list of MFAs that were replaced by expectations If ExcludePassthrough is on, only expectations that are not direct passthroughs are returned","ref":"meck.html#expects/2"},{"type":"function","title":"meck.history/1","doc":"Equivalent to history(Mod, '_') . Return the call history of the mocked module for all processes.","ref":"meck.html#history/1"},{"type":"function","title":"meck.history/2","doc":"Return the call history of the mocked module for the specified process. Returns a list of calls to the mocked module and their results for the specified Pid . Results can be either normal Erlang terms or exceptions that occurred. See also: called/3 , called/4 , history/1 , num_calls/3 , num_calls/4 .","ref":"meck.html#history/2"},{"type":"function","title":"meck.is/1","doc":"creates a matcher/0 instance from either Predicate or HamcrestMatcher . Predicate - is a single parameter function. If it returns true then the argument passed to it is considered as meeting the matcher criteria, otherwise as not. HamcrestMatcher - is a matcher created by Hamcrest-Erlang library","ref":"meck.html#is/1"},{"type":"function","title":"meck.loop/1","doc":"Converts a list of terms into ret_spec() defining a loop of values. It is intended to be in construction of clause specs for the expect/3 function. Calls to an expect, created with ret_spec() returned by this function, will return one element at a time from the Loop list and will restart at the first element when the end is reached.","ref":"meck.html#loop/1"},{"type":"function","title":"meck.loop/4","doc":"Equivalent to expect(Mod, Func, Ari, loop(Loop)) .","ref":"meck.html#loop/4"},{"type":"function","title":"meck.mocked/0","doc":"Returns the currently mocked modules.","ref":"meck.html#mocked/0"},{"type":"function","title":"meck.new/1","doc":"Equivalent to new(Mod, []) .","ref":"meck.html#new/1"},{"type":"function","title":"meck.new/2","doc":"Creates new mocked module(s). This replaces the current version (if any) of the modules in Mod with an empty module. Since this library is intended to use from test code, this function links a process for each mock to the calling process. The valid options are: passthrough Retains the original functions, if not mocked by meck. If used along with stub_all then stub_all is ignored. no_link Does not link the meck process to the caller process (needed for using meck in rpc calls). unstick Unstick the module to be mocked (e.g. needed for using meck with kernel and stdlib modules). no_passthrough_cover If cover is enabled on the module to be mocked then meck will continue to capture coverage on passthrough calls. This option allows you to disable that feature if it causes problems. {spawn_opt, list()} Specify Erlang process spawn options. Typically used to specify non-default, garbage collection options. no_history Do not store history of meck calls. non_strict A mock created with this option will allow setting expectations on functions that does not exist in the mocked module. With this option on it is even possible to mock non existing modules. {stub_all, ret_spec() } Stubs all functions exported from the mocked module. The stubs will return whatever defined by ret_spec() regardless of arguments passed in. It is possible to specify this option as just stub_all then stubs will return atom ok . If used along with passthrough then stub_all is ignored. merge_expects The expectations for the function/arity signature are merged with existing ones instead of replacing all of them each time an expectation is added. Expectations are added to the end of the function clause list, meaning that pattern matching will be performed in the order the expectations were added. Possible exceptions: error:{undefined_module, Mod} The module to be mocked does not exist. This error exists to prevent mocking of misspelled module names. To bypass this and create a new mocked module anyway, use the option non_strict . error:{module_is_sticky, Mod} The module to be mocked resides in a sticky directory. To unstick the module and mock it anyway, use the option unstick . error:{abstract_code_not_found, Mod} The option passthrough was used but the original module has no abstract code which can be called. Make sure the module is compiled with the compiler option debug_info .","ref":"meck.html#new/2"},{"type":"function","title":"meck.num_calls/3","doc":"Equivalent to num_calls(Mod, Fun, Args, '_') . Returns the number of times Mod:Func has been called with Args .","ref":"meck.html#num_calls/3"},{"type":"function","title":"meck.num_calls/4","doc":"Returns the number of times process Pid has called Mod:Func with Args . This will check the history for the module, Mod , to determine how many times process Pid has called the function, Fun , with arguments, Args and returns the result. See also: num_calls/3 .","ref":"meck.html#num_calls/4"},{"type":"function","title":"meck.passthrough/0","doc":"Creates a ret_spec() that makes the original module function be called. Calls to an expect, created with ret_spec() returned by this function, will be forwarded to the original function.","ref":"meck.html#passthrough/0"},{"type":"function","title":"meck.passthrough/1","doc":"Calls the original function (if existing) inside an expectation fun. Note: this code should only be used inside an expect fun.","ref":"meck.html#passthrough/1"},{"type":"function","title":"meck.raise/2","doc":"Creates a ret_spec() that defines an exception. Calls to an expect, created with ret_spec() returned by this function, will raise the specified exception.","ref":"meck.html#raise/2"},{"type":"function","title":"meck.reset/1","doc":"Erases the call history for a mocked module or a list of mocked modules. This function will erase all calls made heretofore from the history of the specified modules. It is intended to prevent cluttering of test results with calls to mocked modules made during the test setup phase.","ref":"meck.html#reset/1"},{"type":"function","title":"meck.seq/1","doc":"Converts a list of terms into ret_spec() defining a sequence of values. It is intended to be in construction of clause specs for the expect/3 function. Calls to an expect, created with ret_spec returned by this function, will exhaust the Sequence list of return values in order until the last value is reached. That value is then returned for all subsequent calls.","ref":"meck.html#seq/1"},{"type":"function","title":"meck.sequence/4","doc":"Equivalent to expect(Mod, Func, Ari, seq(Sequence)) .","ref":"meck.html#sequence/4"},{"type":"function","title":"meck.unload/0","doc":"Unloads all mocked modules from memory. The function returns the list of mocked modules that were unloaded in the process.","ref":"meck.html#unload/0"},{"type":"function","title":"meck.unload/1","doc":"Unload a mocked module or a list of mocked modules. This will purge and delete the module(s) from the Erlang virtual machine. If the mocked module(s) replaced an existing module, this module will still be in the Erlang load path and can be loaded manually or when called.","ref":"meck.html#unload/1"},{"type":"function","title":"meck.val/1","doc":"Converts a term into ret_spec() defining an individual value. It is intended to be in construction of clause specs for the expect/3 function.","ref":"meck.html#val/1"},{"type":"function","title":"meck.validate/1","doc":"Validate the state of the mock module(s). The function returns true if the mocked module(s) has been used according to its expectations. It returns false if a call has failed in some way. Reasons for failure are wrong number of arguments or non-existing function (undef), wrong arguments (function clause) or unexpected exceptions. Validation can detect: When a function was called with the wrong argument types ( function_clause ) When an exception was thrown When an exception was thrown and expected (via meck:exception/2), which still results in true being returned Validation cannot detect: When you didn't call a function When you called a function with the wrong number of arguments ( undef ) When you called an undefined function ( undef ) The reason Meck cannot detect these cases is because of how it is implemented. Meck replaces the module with a mock and a process that maintains the mock. Everything Meck get goes through that mock module. Meck does not insert itself at the caller level (i.e. in your module or in your test case), so it cannot know that you failed to call a module. Use the history/1 or history/2 function to analyze errors.","ref":"meck.html#validate/1"},{"type":"function","title":"meck.wait/4","doc":"Equivalent to wait(1, Mod, OptFunc, OptArgsSpec, '_', Timeout) . Blocks until either function Mod:Func is called at least once with arguments matching OptArgsSpec , or Timeout has elapsed. In the latter case the call fails with error:timeout . The number of calls is counted starting from the most resent call to reset/1 on the mock or from the mock creation, whichever occurred latter. If a matching call has already occurred, then the function returns ok immediately.","ref":"meck.html#wait/4"},{"type":"function","title":"meck.wait/5","doc":"Equivalent to wait(Times, Mod, OptFunc, OptArgsSpec, '_', Timeout) . Blocks until either function Mod:Func is called at least Times with arguments matching OptArgsSpec , or Timeout has elapsed. In the latter case the call fails with error:timeout . The number of calls is counted starting from the most resent call to reset/1 on the mock or from the mock creation, whichever occurred latter. If Times number of matching calls has already occurred, then the function returns ok immediately.","ref":"meck.html#wait/5"},{"type":"function","title":"meck.wait/6","doc":"Blocks until either function Mod:Func is called at least Times with arguments matching OptArgsSpec by process OptCallerPid , or Timeout has elapsed. In the latter case the call fails with error:timeout . The number of calls is counted starting from the most resent call to reset/1 on the mock or from the mock creation, whichever occurred latter. If Times number of matching call has already occurred, then the function returns ok immediately.","ref":"meck.html#wait/6"},{"type":"type","title":"meck.args_spec/0","doc":"Argument specification is used to specify argument patterns throughout Meck. In particular it is used in definition of expectation clauses by expect/3 , expect/4 , and by history digging functions num_called/3 , called/3 to specify what arguments of a function call of interest should look like. An argument specification can be given as a argument pattern list or as a non-negative integer that represents function clause/call arity. If an argument specification is given as an argument pattern, then every pattern element corresponds to a function argument at the respective position. '_' is a wildcard that matches any value. In fact you can specify atom wildcard '_' at any level in the value structure. (E.g.: {1, [blah, {'_', &quot;bar&quot;, 2} | '_'], 3}). It is also possible to use a matcher() created by is/1 in-place of a value pattern. If an argument specification is given by an arity, then it is equivalent to a pattern based argument specification that consists solely of wildcards, and has the length of arity (e.g.: 3 is equivalent to ['_', '_', '_']).","ref":"meck.html#t:args_spec/0"},{"type":"type","title":"meck.func_clause_spec/0","doc":"It is used in expect/3 and expect/4 to define a function clause of complex multi-clause expectations.","ref":"meck.html#t:func_clause_spec/0"},{"type":"type","title":"meck.history/0","doc":"Represents a list of either successful function calls with a returned result or function calls that resulted in an exception with a type, reason and a stack trace. Each tuple begins with the pid of the process that made the call to the function.","ref":"meck.html#t:history/0"},{"type":"opaque","title":"meck.matcher/0","doc":"Matcher is an entity that is used to check that a particular value meets some criteria. They are used in defining expectation where Erlang patterns are not enough. E.g. to check that a numeric value is within bounds. Instances of matcher can be created by is/1 function from either a predicate function or a hamcrest matcher. (see is/1 for details). An instance of this type may be specified in any or even all positions of an arg_spec() .","ref":"meck.html#t:matcher/0"},{"type":"type","title":"meck.meck_mfa/0","doc":"Module, function and arguments that the mock module got called with.","ref":"meck.html#t:meck_mfa/0"},{"type":"type","title":"meck.ret_spec/0","doc":"Opaque data structure that specifies a value or a set of values to be returned by a mock stub function defined by either expect/3 and expect/4 . Values of ret_spec() are constructed by seq/1 , loop/1 , val/1 , exec/1 , and raise/2 functions. They are used to specify return values in expect/3 and expect/4 functions, and also as a parameter of the stub_all option of new/2 function. Note that any Erlang term X is a valid ret_spec() equivalent to meck:val(X) .","ref":"meck.html#t:ret_spec/0"},{"type":"type","title":"meck.stack_trace/0","doc":"Erlang stack trace.","ref":"meck.html#t:stack_trace/0"},{"type":"extras","title":"Meck","doc":"Meck \n A mocking library for Erlang \n\n \n   \n     \n   \n   \n     \n   \n   \n     \n   \n   \n     \n   \n   \n     \n   \n \n\n\n  * [Features](#features)\n  * [Examples](#examples)\n  * [Use](#use)\n  * [Manual Build](#manual-build)\n  * [Caveats](#caveats)\n  * [Contribute](#contribute)","ref":"readme.html"},{"type":"extras","title":"Features - Meck","doc":"See what's new in [0.8 Release Notes][release_notes_0.8].\n\n  * Dynamic return values using sequences and loops of static values\n  * Compact definition of mock arguments, clauses and return values\n  * Pass through: call functions in the original module\n  * Complete call history showing calls, return values and exceptions\n  * Mock validation, will invalidate mocks that were not called correctly\n  * Throwing of expected exceptions that keeps the module valid\n  * Throws an error when mocking a module that doesn't exist or has been\n    renamed (disable with option `non_strict`)\n  * Support for [Hamcrest][hamcrest] matchers\n  * Automatic backup and restore of cover data\n  * Mock is linked to the creating process and will unload automatically\n    when a crash occurs (disable with option `no_link`)\n  * Mocking of sticky modules (using the option `unstick`)","ref":"readme.html#features"},{"type":"extras","title":"Examples - Meck","doc":"Here's an example of using Meck in the Erlang shell:\n\n```erlang\nEshell V5.8.4  (abort with ^G)\n1> meck:new(dog, [non_strict]). % non_strict is used to create modules that don't exist\nok\n2> meck:expect(dog, bark, fun() -> \"Woof!\" end).\nok\n3> dog:bark().\n\"Woof!\"\n4> meck:validate(dog).\ntrue\n5> meck:unload(dog).\nok\n6> dog:bark().\n** exception error: undefined function dog:bark/0\n```\n\nExceptions can be anticipated by Meck (resulting in validation still passing).\nThis is intended to be used to test code that can and should handle certain\nexceptions indeed does take care of them:\n\n```erlang\n5> meck:expect(dog, meow, fun() -> meck:exception(error, not_a_cat) end).\nok\n6> catch dog:meow().\n{'EXIT',{not_a_cat,[{meck,exception,2},\n                    {meck,exec,4},\n                    {dog,meow,[]},\n                    {erl_eval,do_apply,5},\n                    {erl_eval,expr,5},\n                    {shell,exprs,6},\n                    {shell,eval_exprs,6},\n                    {shell,eval_loop,3}]}}\n7> meck:validate(dog).\ntrue\n```\n\nNormal Erlang exceptions result in a failed validation. The following example is\njust to demonstrate the behavior, in real test code the exception would normally\ncome from the code under test (which should, if not expected, invalidate the\nmocked module):\n\n```erlang\n8> meck:expect(dog, jump, fun(Height) when Height > 3 ->\n                                  erlang:error(too_high);\n                             (Height) ->\n                                  ok\n                          end).\nok\n9> dog:jump(2).\nok\n10> catch dog:jump(5).\n{'EXIT',{too_high,[{meck,exec,4},\n                   {dog,jump,[5]},\n                   {erl_eval,do_apply,5},\n                   {erl_eval,expr,5},\n                   {shell,exprs,6},\n                   {shell,eval_exprs,6},\n                   {shell,eval_loop,3}]}}\n11> meck:validate(dog).\nfalse\n```\n\nHere's an example of using Meck inside an EUnit test case:\n\n```erlang\nmy_test() ->\n    meck:new(my_library_module),\n    meck:expect(my_library_module, fib, fun(8) -> 21 end),\n    ?assertEqual(21, code_under_test:run(fib, 8)), % Uses my_library_module\n    ?assert(meck:validate(my_library_module)),\n    meck:unload(my_library_module).\n```\n\nPass-through is used when the original functionality of a module should be kept.\nWhen the option `passthrough` is used when calling `new/2` all functions in the\noriginal module will be kept in the mock. These can later be overridden by\ncalling `expect/3` or `expect/4`.\n\n```erlang\nEshell V5.8.4  (abort with ^G)\n1> meck:new(string, [unstick, passthrough]).\nok\n2> string:strip(\"  test  \").\n\"test\"\n```\n\nIt's also possible to pass calls to the original function allowing us to\noverride only a certain behavior of a function (this usage is compatible with\nthe `passthrough` option). `passthrough/1` will always call the original\nfunction with the same name as the expect is defined in):\n\n```erlang\nEshell V5.8.4  (abort with ^G)\n1> meck:new(string, [unstick, passthrough]).\nok\n2> meck:expect(string, strip, fun\n    (\"foo\") -> \"bar\";\n    (String) -> meck:passthrough([String])\nend).\nok\n3> string:strip(\"  test  \").\n\"test\"\n4> string:strip(\"foo\").\n\"bar\"\n5> meck:unload(string).\nok\n5> string:strip(\"foo\").\n\"foo\"\n```","ref":"readme.html#examples"},{"type":"extras","title":"Use - Meck","doc":"Meck is best used via [Rebar 3][rebar_3]. Add Meck to the test dependencies\nin your `rebar.config`:\n\n```erlang\n{profiles, [{test, [{deps, [meck]}]}]}.\n```","ref":"readme.html#use"},{"type":"extras","title":"Manual Build - Meck","doc":"Meck uses [Rebar 3][rebar_3]. To build Meck go to the Meck directory\nand simply type:\n\n```sh\nrebar3 compile\n```\n\nIn order to run all tests for Meck type the following command from the same\ndirectory:\n\n```sh\nrebar3 eunit\n```\n\nDocumentation can be generated through the use of the following command:\n\n```sh\nrebar3 edoc\n```","ref":"readme.html#manual-build"},{"type":"extras","title":"Test Output - Meck","doc":"Normally the test output is hidden, but if EUnit is run\ndirectly, two things might seem alarming when running the tests:\n\n  1. Warnings emitted by cover\n  2. An exception printed by SASL\n\nBoth are expected due to the way Erlang currently prints errors. The important\nline you should look for is `All XX tests passed`, if that appears all is\ncorrect.","ref":"readme.html#test-output"},{"type":"extras","title":"Caveats - Meck","doc":"","ref":"readme.html#caveats"},{"type":"extras","title":"Global Namespace - Meck","doc":"Meck will have trouble mocking certain modules since it works by recompiling\nand reloading modules in the global Erlang module namespace. Replacing a\nmodule affects the whole Erlang VM and any running processes using that\nmodule. This means certain modules cannot be mocked or will cause trouble.\n\nIn general, if a module is used by running processes or include Native\nImplemented Functions (NIFs) they will be hard or impossible to mock. You may\nbe lucky and it could work, until it breaks one day.\n\nThe following is a non-exhaustive\nlist of modules that can either be problematic to mock or not possible at\nall:\n\n* `erlang`\n* `supervisor`\n* All `gen_` family of modules (`gen_server`, `gen_statem` etc.)\n* `os`\n* `crypto`\n* `compile`\n* `global`\n* `timer` (possible to mock, but used by some test frameworks, like Elixir's\n  ExUnit)","ref":"readme.html#global-namespace"},{"type":"extras","title":"Local Functions - Meck","doc":"A meck expectation set up for a function _f_ does not apply to the module-\nlocal invocation of _f_ within the mocked module. Consider the following module:\n\n```erlang\n-module(test).\n-export([a/0, b/0, c/0]).\n\na() ->\n  c().\n\nb() ->\n  ?MODULE:c().\n\nc() ->\n  original.\n```\n\nNote how the module-local call to `c/0` in `a/0` stays unchanged even though the\nexpectation changes the externally visible behaviour of `c/0`:\n\n```erlang\n3> meck:new(test, [passthrough]).\nok\n4> meck:expect(test,c,0,changed).\nok\n5> test:a().\noriginal\n6> test:b().\nchanged\n6> test:c().\nchanged\n```","ref":"readme.html#local-functions"},{"type":"extras","title":"Common Test - Meck","doc":"When using `meck` under Erlang/OTP's Common Test, one should pay special\nattention to this bit in the chapter on\n[Writing Tests](https://erlang.org/doc/apps/common_test/write_test_chapter.html):\n\n> `init_per_suite` and `end_per_suite` execute on dedicated Erlang processes,\n> just like the test cases do.\n\nCommon Test runs `init_per_suite` in an isolated process which terminates when\ndone, before the test case runs. A mock that is created there will also\nterminate and unload itself before the test case runs. This is because it is\nlinked to the process creating it. This can be especially tricky to detect if\n`passthrough` is used when creating the mock, since it is hard to know if it is\nthe mock responding to function calls or the original module.\n\nTo avoid this, you can pass the `no_link` flag to `meck:new/2` which will unlink\nthe mock from the process that created it. When using `no_link` you should make\nsure that `meck:unload/1` is called properly (for all test outcomes, or\ncrashes) so that a left-over mock does not interfere with subsequent test\ncases.","ref":"readme.html#common-test"},{"type":"extras","title":"Contribute - Meck","doc":"Patches are greatly appreciated! For a much nicer history, please [write good\ncommit messages][commit_messages]. Use a branch name prefixed by `feature/`\n(e.g. `feature/my_example_branch`) for easier integration when developing new\nfeatures or fixes for meck.\n\nShould you find yourself using Meck and have issues, comments or feedback please\n[create an issue here on GitHub][issues].\n\nMeck has been greatly improved by [many contributors](https://github.com/eproxus/meck/graphs/contributors)!","ref":"readme.html#contribute"},{"type":"extras","title":"Donations - Meck","doc":"If you or your company use Meck and find it useful, a [sponsorship][sponsors] or [donations][liberapay] are greatly appreciated!\n\n \n   \n    \n    \n    \n   \n   \n     \n       \n     \n   \n \n\n<!-- Links -->\n[release_notes_0.8]: https://github.com/eproxus/meck/wiki/0.8-Release-Notes\n[hamcrest]: https://github.com/hyperthunk/hamcrest-erlang\n[rebar_3]: https://github.com/erlang/rebar3\n[issues]: http://github.com/eproxus/meck/issues\n[commit_messages]: http://chris.beams.io/posts/git-commit/\n[sponsors]: https://github.com/sponsors/eproxus\n[liberapay]: https://liberapay.com/eproxus/","ref":"readme.html#donations"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}